library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use ieee.numeric_std.all; 

entity vga is
    Port (    
           clk : in std_logic;
           pl1 : in std_logic_vector(7 downto 0);
           pl2 : in std_logic_vector(7 downto 0);
           h_bol : in std_logic_vector(7 downto 0);
		 v_bol : in std_logic_vector(7 downto 0);
           HS : out std_logic;
           VS : out std_logic;
           R : out std_logic;
           G : out std_logic;
           B : out std_logic );
    end vga;

architecture Behavioral of vga is

	signal h_count	: Integer range 0 to 2048;
	signal v_count	: Integer range 0 to 1024;
	signal bol_hpos: Integer;
	signal bol_vpos: Integer;
	signal pl1_pos	: Integer;
	signal pl2_pos	: Integer;

begin

	process (clk)
	begin

	     if clk = '1' and clk'Event then

			if(h_count>=1598) then 
				h_count <= 0;
			else 
				h_count <= h_count + 1;
			end if;

			if(h_count>=1318 and h_count<=1510) then 
				HS <= '0';
			else 
				HS <= '1';
			end if;

			if(v_count>=524 and h_count>=1398) then 
				v_count <= 0;
			elsif (h_count = 1398) then 
				v_count <= v_count+1;
			end if;

			if(v_count<=494 and v_count>=493) then 
				VS <= '0';
			else 
				VS <= '1';
			end if;

			pl1_pos	<= CONV_INTEGER(UNSIGNED(pl1));
			pl2_pos	<= CONV_INTEGER(UNSIGNED(pl2));
			bol_hpos	<= CONV_INTEGER(UNSIGNED(h_bol));
			bol_vpos	<= CONV_INTEGER(UNSIGNED(v_bol));

			if((h_count>=0 and h_count<=256 and  v_count>=94 and v_count<=96) or
			(h_count>=0 and h_count<=256 and  v_count>=0 and v_count<=2) or
			(h_count>=bol_hpos and h_count<=(bol_hpos + 4) and v_count>=(bol_vpos + 2) and v_count<=(bol_vpos + 4)) or
			(h_count>=0 and h_count<=4 and v_count>=(pl1_pos + 2) and v_count<=(pl1_pos + 14)) or
			(h_count>=252 and h_count<=256 and v_count>=(pl2_pos + 2) and v_count<=(pl2_pos + 14))) then 
				R <= '1';
				G <= '1';
				B <= '1';
			else
				R <= '0';
				G <= '0';
				B <= '0';
			end if;

		end if;

	end process;

end Behavioral;